<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des catégories n'ont pas pu être chargées."
    />
    <template v-else-if="ministereCategorieCounts">
      <h2 class="fr-h5">Catégories</h2>
      <StatsList
        v-if="ministereCategorieCounts.length"
        :total-count="beneficiaryCount"
        :stats="ministereCategorieCounts"
        stats-bar
      />
      <p v-else>
        Commencez à
        <NuxtLink
          :to="Routes.BeneficiariesAdd"
          target="_self"
          >créer des fiches de bénéficiaires</NuxtLink
        >
        pour voir apparaître les statistiques de la répartition des catégories.
      </p>
    </template>
  </div>
</template>

<script setup>
  import { MINISTERE_CATEGORIE_OPTIONS } from '~/utils/constants/beneficiary'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { labelOrUnprovided } from '~~/utils/stats'
  import { Routes } from '~/utils/routing/routes'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    beneficiaryCount: {
      type: Number,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: ministereCategorieCounts,
    pending,
    error,
    refresh
  } = useLazyAsyncData(
    'ministereCategorieCounts',
    loadMinistereCategorieCounts,
    {
      server: false
    }
  )

  watch(() => props.filters, refresh)

  async function loadMinistereCategorieCounts() {
    const res = await $getItems('beneficiary', {
      groupBy: 'ministere_categorie',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const categorieResCounts = res.data.data.map(categorie => ({
        key: categorie.ministere_categorie,
        label: labelOrUnprovided(
          categorie.ministere_categorie,
          MINISTERE_CATEGORIE_OPTIONS
        ),
        count: parseInt(categorie.countDistinct.id)
      }))
      categorieResCounts.sort((a, b) => b.count - a.count)
      return categorieResCounts
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
